"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
function _export(target, all) {
  for (var name in all)
    Object.defineProperty(target, name, {
      enumerable: true,
      get: all[name]
    });
}
_export(exports, {
  createBabelChain: function() {
    return createBabelChain;
  },
  babelChain: function() {
    return babelChain;
  }
});
const _preset = require("./preset");
const _plugin = require("./plugin");
const _plain = require("./plain");
const createBabelChain = () => {
  const presetChain = (0, _preset.createBabelPresetChain)();
  const pluginChain = (0, _plugin.createBabelPluginChain)();
  const plainChain = (0, _plain.createBabelPlainChain)();
  const merge = (other) => {
    presetChain.merge(other.internal.preset);
    pluginChain.merge(other.internal.plugin);
    plainChain.merge(other.internal.plain);
    return chain;
  };
  const toJSON = () => ({
    ...plainChain.toJSON(),
    presets: presetChain.toJSON(),
    plugins: pluginChain.toJSON()
  });
  const chain = {
    ...plainChain.plain,
    plugin: pluginChain.plugin,
    preset: presetChain.preset,
    toJSON,
    merge,
    get internal() {
      return {
        preset: presetChain,
        plugin: pluginChain,
        plain: plainChain
      };
    }
  };
  return chain;
};
const babelChain = createBabelChain();
